// CHKClockDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CHKClock.h"
#include "CHKClockDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_applicationName;
	long	m_totalphysical;
	CString	m_username;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_applicationName = _T("");
	m_totalphysical = 0;
	m_username = _T("");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_STATICAPPLICATION, m_applicationName);
	DDX_Text(pDX, IDC_STATICTOTALPHYSICAL, m_totalphysical);
	DDX_Text(pDX, IDC_STATICUSERNAME, m_username);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCHKClockDlg dialog
void CALLBACK MyTimerProc(HWND hwnd, UINT message, UINT idTimer, DWORD dwTime); 

CCHKClockDlg::CCHKClockDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCHKClockDlg::IDD, pParent)
{

	//{{AFX_DATA_INIT(CCHKClockDlg)
	m_edclock1 = _T("");
	m_edclock2 = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDI_CLOCK);
}

void CCHKClockDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCHKClockDlg)
	DDX_Control(pDX, IDC_STOPTIMER, m_bstoptimer);
	DDX_Control(pDX, IDC_SETTIMER, m_bsettimer);
	DDX_Text(pDX, IDC_EDCLOCK1, m_edclock1);
	DDX_Text(pDX, IDC_EDCLOCK2, m_edclock2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCHKClockDlg, CDialog)
	//{{AFX_MSG_MAP(CCHKClockDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_SETTIMER, OnSettimer)
	ON_BN_CLICKED(IDC_STOPTIMER, OnStoptimer)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCHKClockDlg message handlers

BOOL CCHKClockDlg::OnInitDialog()
{
    UINT uResult;    	// SetTimer's return value

	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{

		pSysMenu->RemoveMenu(SC_SIZE, MF_BYCOMMAND);
		pSysMenu->RemoveMenu(SC_MAXIMIZE, MF_BYCOMMAND);
		
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

    //SetTimer(timer identifier,time-out value,timer callback)
	uResult = SetTimer(1, 110, (TIMERPROC) MyTimerProc);   
	
	if (uResult == 0) 
		ErrorHandler("No timer is available."); 

	UpdateData(FALSE); 
 
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCHKClockDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCHKClockDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCHKClockDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// MyTimerProc is an application-defined callback function that 
// processes WM_TIMER messages.

void CALLBACK MyTimerProc(HWND hwnd,  // handle of window for timer messages 
		    UINT message,     // WM_TIMER message 
		    UINT idTimer,     // timer identifier 
		    DWORD dwTime)     // current system time 
{

	const int	getLen = 127;
	SYSTEMTIME  SysTime;
	CHAR		sz[40], sz1[40];

	GetLocalTime(&SysTime);
//*********************** 1st clock type ****************************
    itoa(SysTime.wHour, sz, 10);
    strcat(sz, " : ");
    itoa(SysTime.wMinute, &sz[strlen(sz)], 10);
    strcat(sz, " : ");
    itoa(SysTime.wSecond, &sz[strlen(sz)], 10);
	strcat(sz, " : ");
    itoa(SysTime.wMilliseconds, &sz[strlen(sz)], 10);

	SetDlgItemText(hwnd,IDC_EDCLOCK1,sz);
	GetDlgItemText(hwnd,IDC_EDCLOCK1, sz, getLen);
//************************ 2sd clock type ***************************

	if (SysTime.wHour > 12)
		itoa(SysTime.wHour - 12 , sz1, 10);
	else
		itoa(SysTime.wHour, sz1, 10);

	strcat(sz1, ":");
    itoa(SysTime.wMinute, &sz1[strlen(sz1)], 10);
    strcat(sz1, ":");
    itoa(SysTime.wSecond, &sz1[strlen(sz1)], 10);

	if (SysTime.wHour > 12)
		strcat(sz1, " PM");
	else
		strcat(sz1, " AM");

	SetDlgItemText(hwnd,IDC_EDCLOCK2,sz1);
	GetDlgItemText(hwnd,IDC_EDCLOCK2, sz1, getLen); 

}

void CCHKClockDlg::ErrorHandler(LPSTR lpszErrorStr)
{
	char	szStr[200];
	wsprintf(szStr, lpszErrorStr);
	MessageBox(szStr, "Digital Clock", MB_OK);
} 


void CCHKClockDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
    // Destroy timer, Digital clocks part
    KillTimer(1); 

	// Destroy timer, Timer part
	KillTimer(m_uTimerID);

	// TODO: Add your message handler code here
	
}



void CCHKClockDlg::OnSettimer() 
{
	m_uTimerID = SetTimer(IDD_CHKCLOCK_DIALOG,1,NULL);

	b_set = true;
	b_start = true;

	m_bsettimer.EnableWindow(FALSE);
	m_bstoptimer.EnableWindow(TRUE);

	// TODO: Add your control notification handler code here
	
}

void CCHKClockDlg::OnStoptimer() 
{
	b_set = false;
	m_bsettimer.EnableWindow(true);
	m_bstoptimer.EnableWindow(FALSE);

	KillTimer(m_uTimerID);
	// TODO: Add your control notification handler code here
	
}

void CCHKClockDlg::OnTimer(UINT nIDEvent) 
{
	time(&vtime_t);
	vtm = localtime(&vtime_t);

    itoa(vtm->tm_hour, szt, 10);
    strcat(szt, " : ");
    itoa(vtm->tm_min, &szt[strlen(szt)], 10);
    strcat(szt, " : ");
    itoa(vtm->tm_sec, &szt[strlen(szt)], 10);

	if (b_set) {
		if (b_start) {

			SetDlgItemText(IDC_EDBEGN,szt);
			time(&v_starttime);
			b_start = false;
		}
		time(&v_stoptime);
		SetDlgItemText(IDC_EDSTOP,szt);
		if (v_stoptime != v_starttime) {
			
			d_interval = difftime(v_stoptime,v_starttime);
			SetDlgItemInt(IDC_EDINTERVAL, (INT)d_interval, TRUE);
		}
	}

	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnTimer(nIDEvent);
}




BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	
	CWinApp* pApp = AfxGetApp();

	//Application Name
	m_applicationName = AfxGetApp()->m_pszAppName;

    // User Name 
	char pszUser[150];
	DWORD cchUser = 150;
 
	GetUserName (pszUser, &cchUser); 
	m_username = (CString)pszUser;
    
	// Memory 
    MEMORYSTATUS ms            = {0}; 
    ZeroMemory(&ms, sizeof(MEMORYSTATUS)); 
    ms.dwLength = sizeof(MEMORYSTATUS); 
    GlobalMemoryStatus(&ms); 

	m_totalphysical = (long)ms.dwTotalPhys;

	UpdateData(FALSE);
	
 
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
